pipeline {
  agent any
  environment {
    SEMGREP_APP_TOKEN = credentials('SEMGREP_APP_TOKEN')
  }
  stages {
    stage('Semgrep-Cloud SAST') {
      steps {
        sh '~/.local/bin/semgrep ci'
      }
    }
    stage('Semgrep-OSS SAST') {
      steps {
        script {
          def semgrepCommand = "docker run -v ${WORKSPACE}:/src --workdir /src returntocorp/semgrep-agent:v1 semgrep-agent --config p/secrets"
          def exitCode = sh(returnStatus: true, script: semgrepCommand)
          if (exitCode != 0) {
            echo "Semgrep-OSS SAST scan found issues, but the pipeline will continue."
          }
        }
      }
    }
    stage('Semgrep-SCA') {
      steps {
        sh '~/.local/bin/semgrep ci --supply-chain'
      }
    }
  }
  post {
    always {
      script {
        deleteDir()
      }
    }
  }
}
